<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "provider_medication".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "ProviderMedication".
 *
 * Columns in table "provider_medication" available as properties of the model,
 * followed by relations of table "provider_medication" available as properties of the model.
 *
 * @property integer $id
 * @property integer $provider_id
 * @property integer $medication_id
 *
 * @property Medication $medication
 * @property Provider $provider
 */
abstract class BaseProviderMedication extends BaseModel
{

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'provider_medication';
    }

    public static function representingColumn()
    {
        return 'id';
    }

    public function rules()
    {
        return array(
            array('provider_id, medication_id', 'required'),
            array('provider_id, medication_id', 'numerical', 'integerOnly' => true),
            array('id, provider_id, medication_id', 'safe', 'on' => 'search'),
        );
    }

    public function relations()
    {
        return array(
            'medication' => array(self::BELONGS_TO, 'Medication', 'medication_id'),
            'provider' => array(self::BELONGS_TO, 'Provider', 'provider_id'),
        );
    }

    public function pivotModels()
    {
        return array(
        );
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'provider_id' => Yii::t('app', 'Provider'),
            'medication_id' => Yii::t('app', 'Medication'),
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;

        $criteria->compare('id', $this->id);
        //$criteria->compare('provider_id', $this->provider_id);
        //it will search by id or provider.first_last
        if (!intval($this->provider_id) && is_string($this->provider_id) && strlen($this->provider_id) > 0) {
            $criteria->with[] = 'provider';
            $criteria->addSearchCondition("provider.first_last", $this->provider_id);
        } else {
            $criteria->compare('provider_id', $this->provider_id);
        }
        //$criteria->compare('medication_id', $this->medication_id);
        //it will search by id or provider.first_last
        if (!intval($this->medication_id) && is_string($this->medication_id) && strlen($this->medication_id) > 0) {
            $criteria->with[] = 'medication';
            $criteria->addSearchCondition("medication.name", $this->medication_id);
        } else {
            $criteria->compare('medication_id', $this->medication_id);
        }

        return new CActiveDataProvider(
            get_class($this),
            array(
                'criteria' => $criteria,
                'pagination' => array('pageSize' => 100)
            )
        );
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'ProviderMedication|ProviderMedications', $n);
    }

}
